﻿Imports System.ComponentModel
Imports System.IO.Ports

Public Class Form1

    Private _port As SerialPort

    Public ReadOnly Property PortNames As BindingList(Of String)

    Public ReadOnly Property Baudrates As BindingList(Of Integer)

    Sub New()
        InitializeComponent()
        _port = New SerialPort()
        AddHandler _port.ErrorReceived, AddressOf Port_ErrorReceived
        AddHandler _port.DataReceived, AddressOf Port_DataReceived
        PortNames = New BindingList(Of String)()
        RefreshPortNames()
        cbbComPorts.DataSource = PortNames
        Baudrates = New BindingList(Of Integer)()
        RefreshBaudrates()
        cbbBaudrates.DataSource = Baudrates
    End Sub

    Private Sub RefreshPortNames()
        PortNames.Clear()
        For Each portName In SerialPort.GetPortNames()
            If Not portName = "COM1" Then
                PortNames.Add(portName)
            End If
        Next
    End Sub

    Private Sub RefreshBaudrates()
        Baudrates.Add(9600)
        Baudrates.Add(19200)
        Baudrates.Add(38400)
        Baudrates.Add(115200)
    End Sub

    Private Sub cbbComPorts_SelectionChangeCommitted(sender As Object, e As EventArgs) Handles cbbComPorts.SelectionChangeCommitted
        If _port.IsOpen Then
            _port.Close()
        End If
        _port.PortName = Convert.ToString(cbbComPorts.SelectedItem)
        _port.Open()
    End Sub

    Private Sub cbbBaudrates_SelectionChangeCommitted(sender As Object, e As EventArgs) Handles cbbBaudrates.SelectionChangeCommitted
        'If _port.IsOpen Then
        '    _port.Close()
        'End If
        _port.BaudRate = Convert.ToInt32(cbbBaudrates.SelectedItem)
        ' _port.Open()
    End Sub

    Private Sub btnSendCmd_Click(sender As Object, e As EventArgs) Handles btnSendCmd.Click
        SendCmd()
    End Sub

    Private Sub tbCmd_KeyDown(sender As Object, e As KeyEventArgs) Handles tbCmd.KeyDown
        If e.KeyCode = Keys.Enter Then
            e.Handled = True
            e.SuppressKeyPress = True
            SendCmd()
        End If
    End Sub

    Private Sub SendCmd()
        If Not _port.IsOpen Then
            _port.PortName = Convert.ToString(cbbComPorts.SelectedItem)
            _port.BaudRate = Convert.ToInt32(cbbBaudrates.SelectedItem)
            _port.Open()
        End If
        _port.WriteLine(tbCmd.Text)
        tbCmd.Text = ""
    End Sub

    Private Sub Port_ErrorReceived(sender As Object, e As SerialErrorReceivedEventArgs)
        BeginInvoke(Sub()
                        TextBox1.AppendText("error received")
                    End Sub)
    End Sub

    Private Sub Port_DataReceived(sender As Object, e As SerialDataReceivedEventArgs)
        Dim data = _port.ReadExisting()
        BeginInvoke(Sub()
                        TextBox1.AppendText(data)
                    End Sub)
    End Sub

End Class
